
//Air combat by ngoodin
//ngoodinja@hotmail.com
//23-8-2007
//this program demonstrates how to
//write Game with PocketC#
using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
class grx : Form
{
 //sound P/Invoke
 [DllImport("coredll", EntryPoint="PlaySound", SetLastError=true) ]
 private extern static bool PlaySound(String lpszName, int hModule, int dwFlags);
 //Graphics declaration
 Graphics grBuffer;
 Graphics grBackground;
 Bitmap spritePlane=new Bitmap(60,60);
 Bitmap buffer=new Bitmap(240,320);
 Bitmap background=new Bitmap(240,320);
 Bitmap spriteEnemy=new Bitmap(60,60);
 Bitmap spriteExpl1=new Bitmap(60,60);
 Bitmap spriteExpl2=new Bitmap(60,60);
 Bitmap spritePowerup=new Bitmap(20,20);
 //Sprite position
 int spriteX,spriteY;
 //control position
 int controlX,controlY;
 //myplane&enemyplane rectangle
 Rectangle myPlaneRec=new Rectangle(0,0,30,30);
 Rectangle enemyPlaneRec=new Rectangle(0,0,30,30);
 Rectangle enemyPlaneRec2=new Rectangle(0,0,30,30);
 //powerupRec
 Rectangle powerupRec=new Rectangle(0,0,20,20);
 
 //enemy position
 int enemyX,enemyY,enemy2X,enemy2Y;
 //enemy control position
 int enControlX,enControlY,enControl2X,enControl2Y;
 //show powerup
 bool showPowerup=false; 
 int powerupX=0;
 int powerupY=0;
 
 //set timer
 Timer  m_tmr = new Timer();
 //Random light
 Random rand=new Random();
 //light position and size
 int rndX,rndSize;
 //transparency
 ImageAttributes imgattr = new ImageAttributes();
 
 //shield score
 Font messageFont = new Font(FontFamily.GenericSansSerif,10, FontStyle.Regular);
 Rectangle messageRectangle = new Rectangle(170,0,100,30);
 SolidBrush messageBrush=new SolidBrush(Color.Yellow) ;
 string messageString;
 int shield=20;
 //time score
 Font timeFont = new Font(FontFamily.GenericSansSerif,10, FontStyle.Regular);
 Rectangle timeRectangle = new Rectangle(0,0,100,30);
 SolidBrush timeBrush=new SolidBrush(Color.Yellow) ;
 string timeString;
 int time=0;
 //end message
 Font endFont = new Font(FontFamily.GenericSansSerif,10, FontStyle.Bold);
 Rectangle endRectangle = new Rectangle(40,100,200,20);
 SolidBrush endBrush=new SolidBrush(Color.White) ;
 string endString="You lose,please try again.";
 
 //credit message
 Font creditFont = new Font(FontFamily.GenericSansSerif,10, FontStyle.Bold);
 Rectangle creditRectangle = new Rectangle(20,275,240,20);
 SolidBrush creditBrush=new SolidBrush(Color.Orange) ;
 string creditString="ngoodinja@hotmail.com:23-8-07";
 static void Main()
 {
  Application.Run(new grx());
 } 
 grx()
 {
  //Form header
  MinimizeBox=false;
  Text="AirCombat Game";
  //create graphics in Buffer
  grBuffer=Graphics.FromImage(buffer);
  initSprite();
  
  //set time interval  
  m_tmr.Interval = 10;
  // Specify the timer callback method
  m_tmr.Tick += new EventHandler(OnTimerTick);
  // Start the timer
  m_tmr.Enabled = true;  
 }
 private void initSprite()
 {
  //my plane
  spriteX=0;
  spriteY=0;
  controlX=100;
  controlY=250;
  Graphics gr=Graphics.FromImage(spritePlane);
  gr.FillRectangle(new SolidBrush(Color.Blue),21,5,8,35);
  gr.FillRectangle(new SolidBrush(Color.Blue),4,14,45,10);
  gr.FillRectangle(new SolidBrush(Color.Blue),13,33,25,7);
  gr.FillEllipse(new SolidBrush(Color.Yellow),22,15,6,9);
  gr.Dispose();
  //enemy planes
  enemyX=240;
  enemyY=0;
  enControlX=100;
  enControlY=200;
  enemy2X=-50;
  enemy2Y=0;
  enControl2X=100;
  enControl2Y=130;
  gr=Graphics.FromImage(spriteEnemy);
  gr.FillRectangle(new SolidBrush(Color.Violet),21,5,8,35);
  gr.FillRectangle(new SolidBrush(Color.Green),4,22,45,10);
  gr.FillRectangle(new SolidBrush(Color.Green),13,5,25,7);
  gr.FillEllipse(new SolidBrush(Color.Cyan),22,22,6,9);
  gr.Dispose();
  //explosion1
  gr=Graphics.FromImage(spriteExpl1);
  gr.FillEllipse(new SolidBrush(Color.White),10,10,30,30);  
  gr.FillEllipse(new SolidBrush(Color.Red),30,4,30,25);
  //explosion2
  gr=Graphics.FromImage(spriteExpl2);
  gr.FillEllipse(new SolidBrush(Color.White),25,25,15,20);  
  gr.FillEllipse(new SolidBrush(Color.Orange),15,7,25,20);
  //powerup ball
  gr=Graphics.FromImage(spritePowerup);
  gr.FillEllipse(new SolidBrush(Color.Red),2,2,15,15);
  gr.FillEllipse(new SolidBrush(Color.White),4,4,5,5);
  gr.Dispose();
 }
 private void OnTimerTick(object sender, EventArgs evArgs)
 {
  myPlaneMove(); 
  enemyMove();
  enemyAttack();
  updateBackground();
  drawAllPlanes();  
  checkCollision();
  drawScore();
  Invalidate();
  grBuffer.Dispose();
  checkEnd();
  time++;
 }
 private void checkEnd()
 {
  if(shield<0)
  {
   freeze();
   grBuffer.Dispose();
   grBackground.Dispose();
   buffer.Dispose();
   spritePlane.Dispose();
   spriteEnemy.Dispose();
   background.Dispose();
   spriteExpl1.Dispose();
   spriteExpl2.Dispose();
   m_tmr.Dispose();
   
   Application.Exit();
  }
 }
 private void freeze()
 {
  for(int i=0;i<1000000;i++)
  {
   for(int j=0;j<100;j++)
   {
    //delay for awhile
   }
  }
 }
 
 private void drawScore()
 {
  messageString="Shield="+shield.ToString();
  grBuffer.DrawString(messageString,messageFont,messageBrush,messageRectangle);
  timeString="TimeScore="+time.ToString();
  grBuffer.DrawString(timeString,timeFont,timeBrush,timeRectangle);
  grBuffer.DrawString(creditString,creditFont,creditBrush,creditRectangle);
 }
 
 private void checkCollision()
 {
  myPlaneRec.X=spriteX;
  myPlaneRec.Y=spriteY;
  enemyPlaneRec.X=enemyX;
  enemyPlaneRec.Y=enemyY;
  enemyPlaneRec2.X=enemy2X;
  enemyPlaneRec2.Y=enemy2Y;
  powerupRec.X=powerupX;
  powerupRec.Y=powerupY;
  if ( myPlaneRec.IntersectsWith(enemyPlaneRec)
   ||myPlaneRec.IntersectsWith(enemyPlaneRec2)) 
  {
   drawExplosion();
   PlaySound("online",0,1);
   shield--;
   if(shield<=0)
    grBuffer.DrawString(endString,endFont,endBrush,endRectangle);
  }
  
  if(showPowerup)
   if( myPlaneRec.IntersectsWith(powerupRec))
   {
    PlaySound("msgbox",0,1);
    shield+=10;
    showPowerup=false;
   }
  
 }
 private void drawExplosion()
 {
  //draw random explosion
  imgattr.SetColorKey(spriteExpl1.GetPixel(0,0), spriteExpl1.GetPixel(0,0));
  rndX=rand.Next(3);
  if(rndX==2)
   grBuffer.DrawImage(spriteExpl1, new Rectangle(spriteX, spriteY,60,
  60), 0, 0, 60, 60,
  GraphicsUnit.Pixel, imgattr);
  else
  grBuffer.DrawImage(spriteExpl2, new Rectangle(spriteX, spriteY,60,
  60), 0, 0, 60, 60,
  GraphicsUnit.Pixel, imgattr);
 }
 
 
 private void drawAllPlanes()
 {
  //draw myplane
  imgattr.SetColorKey(spritePlane.GetPixel(0,0), spritePlane.GetPixel(0,0));
  grBuffer.DrawImage(spritePlane, new Rectangle(spriteX, spriteY,60,
  60), 0, 0, 60, 60,
  GraphicsUnit.Pixel, imgattr);
  //draw enemy plane
  imgattr.SetColorKey(spriteEnemy.GetPixel(0,0), spriteEnemy.GetPixel(0,0));
  grBuffer.DrawImage(spriteEnemy, new Rectangle(enemyX, enemyY,60,
  60), 0, 0, 60, 60,
  GraphicsUnit.Pixel, imgattr);
  //draw enemy plane2
  imgattr.SetColorKey(spriteEnemy.GetPixel(0,0), spriteEnemy.GetPixel(0,0));
  grBuffer.DrawImage(spriteEnemy, new Rectangle(enemy2X, enemy2Y,60,
  60), 0, 0, 60, 60,
  GraphicsUnit.Pixel, imgattr);
  //draw powerup
  
  if(!showPowerup)
  {
//probability to show poweup is 1:100
   rndX=rand.Next(100);
   if(rndX==1)
   {
    showPowerup=true;
    powerupX=rand.Next(220);
    powerupY=0;
   }
  }
  
  if(showPowerup)
  {
   //draw powerup
   imgattr.SetColorKey(spritePowerup.GetPixel(0,0), spritePowerup.GetPixel(0,0));
   grBuffer.DrawImage(spritePowerup, new Rectangle(powerupX, powerupY,20,
   20), 0, 0, 20, 20,
   GraphicsUnit.Pixel, imgattr); 
   powerupY+=4;
   
   if(powerupY>320)
    showPowerup=false;
  }  
  
 }
 
 private void enemyAttack()
 {
  //enemy1
  enControlX=spriteX;
  enControlY=320;
  if(enemyY>300)
  {
   enemyY=0;
   enemyX=rand.Next(400)-100;
  }
  //enemy2
  enControl2X=controlX;
  enControl2Y=320;
  if(enemy2Y>300)
  {
   enemy2Y=0;
   enemy2X=rand.Next(400)-100;
  }
 }
 private void myPlaneMove()
 {
  if(spriteX<controlX)
   spriteX+=3;
  if(spriteX>controlX)
   spriteX-=3;
  if(spriteY<controlY)
   spriteY+=3;
  if(spriteY>controlY)
   spriteY-=3;
 }
 private void enemyMove()
 {
  //enemy1
  if(enemyX<enControlX)
   enemyX+=2;
  if(enemyX>enControlX)
   enemyX-=2;
  if(enemyY<enControlY)
   enemyY+=4;
  if(enemyY>enControlY)
   enemyY-=4;
  //enemy2
  if(enemy2X<enControl2X)
   enemy2X+=2;
  if(enemy2X>enControl2X)
   enemy2X-=2;
  if(enemy2Y<enControl2Y)
   enemy2Y+=3;
  if(enemy2Y>enControl2Y)
   enemy2Y-=3;
  
 } 
 private void updateBackground()
 {
  rndX=rand.Next(240);
  rndSize=rand.Next(3);
  grBackground=Graphics.FromImage(background);
  grBackground.FillRectangle(new SolidBrush(Color.Gray),rndX,5,rndSize,rndSize);
  grBackground.DrawImage(background,0,2);
  grBuffer.DrawImage(background,0,0);
  grBackground.Dispose();
 }
 
 protected override void OnPaintBackground(PaintEventArgs p)
 {
 }
 protected override void OnPaint(PaintEventArgs p)
 {
  p.Graphics.DrawImage(buffer,0,0);
 }
 
 protected override void OnKeyDown(KeyEventArgs e)
 {
  switch(e.KeyCode)
  {
   case Keys.Right:
   {
    controlX=190;
    break;
   }
   case Keys.Left:
   {
    controlX=0;
    break;
   }
   case Keys.Down:
   { 
    controlY=250;
    break;
   }
   case Keys.Up:
   { 
    controlY=0;
    break;
   }
  }
 }
 
 protected override void OnMouseMove(MouseEventArgs e)
 {
  controlX=e.X;
  controlY=e.Y;
 }
} 




